/*
 * CARNAC interface
 * prediction of secondary structure of RNA
 *
 */


import java.io.*;
import java.util.*;


/**
 * This is the Thread which run naview Program
 *
 *
 */

public class NaviewThread extends Thread  {
    private File ctFile;
    
    private File command = new File("naview.sh");
	
	private boolean running = false;
	private Process process;
	
	
	
	public NaviewThread(){
		super();
	}
	
	/**
	 *
	 */
	public NaviewThread(int idxSeq1, int idxSeq2){
		super();
		this.ctFile = new File("str." + Sequence.getStr(idxSeq1) + "." + Sequence.getStr(idxSeq2) + ".ct");
	}
	
	
	public NaviewThread(File ctFile){
		super();
		this.ctFile = ctFile;
		start();
	}

	

	public boolean isRunning() {
		return running;
	}
	
    
	/**
     * Set File
     */
    public void setFile(File ctFile){
		this.ctFile = ctFile;
		System.out.println (ctFile.getName());
    }
	
    
    /**
     * Set program name
     */
    public void setBin(File file){
        this.command = file;
    }
    
	
    
    
	private boolean runProcess()  {
        if (this.ctFile == null)
            return false;
		String commandStr = command.getAbsolutePath() + " " + this.ctFile.getAbsolutePath();
		if (running)
			return true;
		try {
			process = Runtime.getRuntime().exec(commandStr);
		}catch (IOException e) { System.err.println("error naview"); return false;}
		running = true;
        return true;
	}

	
	public void killProcess(){
		if (running) {
			process.destroy();
			running = false;
		}
	}

	
	public void run() {
	
		if (! runProcess())
            return;
		//statusLabel.setText("CARNAC : Process Running... on " + file.getName());
		//statusLabel.updateUI();
		
		try {
			process.waitFor(); 
			} catch (InterruptedException e) { System.err.println("error wait"); } 
		if (running) {

			running = false;
       
		}
	
	}
}

	
	
	
