/*
 *    Stem
 */

import java.io.*;
import java.lang.*;
import java.util.*;


/**
 * Stem structure
 */
public class Stem {
	private String label; /* Label of the Stem */
	
	public int i1, i2, i3, i4;
	public int x1, x2, x3, x4;
	
	private int energy; /* Energy (negative) */
	private boolean isEmpty;
	
	/**
	 * Construct an empty Stem
	 */
	public Stem(){
	 isEmpty = true;
	 label = new String("**");
	}

	/**
	 * Construct a Stem with abciss i1, i2, i3, i4
	 */
	public Stem(int i1, int i2, int i3, int i4) {
		this.i1 = i1;
		this.x1 = i1;
		this.i2 = i2;
		this.x2 = i2;
		this.i3 = i3;
		this.x3 = i3;
		this.i4 = i4;
		this.x4 = i4;
		this.isEmpty = false;
	}
	
	
	/**
	 * Construct a Stem based on the parameter Stem stem
	 */
	public Stem(Stem stem){
		this.i1 = stem.i1;
		this.i2 = stem.i2;
		this.i3 = stem.i3;
		this.i4 = stem.i4;
		this.x1 = stem.x1;
		this.x2 = stem.x2;
		this.x3 = stem.x3;
		this.x4 = stem.x4;
		this.energy = stem.energy;
		this.label = stem.label;
		this.isEmpty = stem.isEmpty;
	}
	
	
	public boolean isEmpty() {
		return isEmpty;
	}
	
	public int getWidth() {
		return x4 - x1;
	}
	
	public int getMiddle() {
		return (int) ((float) (x4 + x1) / 2.0);
	}
	
	
	
	public String getLabel() {
		return label;
	}
	public int energy() {
		return energy;
	}
	
}
