

/*----------------------------------------------*/
/* types.c                                      */
/*----------------------------------------------*/

#include "types.h"

// int
vector_t new_vector (int size)
 {vector_t z; z = (vector_t) calloc((size+1),sizeof(int));
  z[0] = -1; return z;}
void add_to_vector (vector_t *z, int last)
 {int size = vectorlength(*z);
  (*z) = (vector_t) realloc(*z,(size+2)*sizeof(int));
  (*z)[size] = last; (*z)[size+1] = -1;}
int vectorlength (vector_t z)
{int i; for(i=0; (z[i]!=-1); i++); return i;}

// tiges
stem_t new_stem (int seq, int rank, int flag, int i, int j, int k, int l, int energy) {
  stem_t new;
  new = (stem_t) malloc(sizeof(_stem_t));
  new -> seq = seq;
  new -> energy = energy;
  new -> flag = flag;
  new -> s[0] = rank;
  new -> s[1] = i;
  new -> s[2] = j;
  new -> s[3] = k;
  new -> s[4] = l;
  new -> shortened = 0;
  new -> substem = 0;
  new -> lonely = 1;
  new -> forced = NULL;
  new -> married = NULL;
  new -> equiv = NULL;
  new -> g_node = -1;
  new -> k_bounds.min = -1;
  new -> k_bounds.max = -1;
  new -> l_bounds.min = -1;
  new -> l_bounds.max = -1;
  new -> folded = 0;
  new -> last_in  = -1;
  new -> last_out = -1;
  new -> next_in  = -1;
  new -> next_out = -1;
  new -> freq = 1;
  new -> connectivity = 0;
  new -> tag = 0;
  new -> true_match = 0;
  new -> sig = -1;
  new -> rel = -1;
  new -> index = -1;
  return new;}

stem_list_t new_stem_list (int size) {
  stem_list_t new_list;
  new_list = (stem_list_t) calloc((size+1), sizeof(stem_t));
  new_list[0] = NULL; return new_list;}
cpl_stem_list_t new_cpl_stem_list (int size) {
  cpl_stem_list_t new_list; int i;
  new_list = (cpl_stem_list_t) malloc((size+1)*sizeof(stem_list_t));
  for (i=0; i<=size; i++) new_list[i] = (stem_list_t) malloc(2*sizeof(stem_t));
  new_list[0][0] = NULL; new_list[0][1] = NULL; return new_list;}
void add_stem_list (stem_list_t *L, stem_t P) {
  int size = stem_list_length(*L);
  (*L) = (stem_list_t) realloc(*L,(size+2)*sizeof(stem_t));
  (*L)[size] = P;
  (*L)[size+1] = NULL;}
int stem_list_length (stem_list_t K)
{int i=-1; if (K!=NULL) for(i=0; (K[i]!=NULL); i++); return i;}
int cpl_stem_list_length (cpl_stem_list_t K)
{int i=-1; if (K!=NULL) for(i=0; (K[i][0]!=NULL) || (K[i][1]!=NULL); i++); return i;}
stem_list_t cat_stem_list (stem_list_t K1, stem_list_t K2) {
  int i, n1, n2; stem_list_t K;
  n1 = stem_list_length (K1); n2 = stem_list_length (K2);
  K = new_stem_list (n1 + n2);
  for (i=0; i<n1; i++) K[i] = K1[i];
  for (i=0; i<n2; i++) K[n1+i] = K2[i];
  K[n1+n2] = NULL; free(K1); free(K2); return K;}
int belongs (stem_t P, stem_list_t K) {
  int i, n, out; n = stem_list_length (K); out = 0;
  for (i=0; i<n; i++) if (P == K[i]) out++; return out;}

// quick sort by decreasing frequencies (then decreasing energies)
int compare_freq (const void* alpha1, const void* alpha2)
{stem_list_t K1, K2; K1 = (stem_list_t) alpha1; K2 = (stem_list_t) alpha2;
 if (((*K1) -> freq < (*K2) -> freq) ||
     (((*K1) -> freq == (*K2) -> freq) &&
      ((*K1) -> energy > (*K2) -> energy)))
   return 1; else return -1;}
void sort_stems_by_freq (stem_list_t K)
{int i; int nK = stem_list_length(K);
 qsort(K, nK, sizeof(stem_t), compare_freq);
 for (i=0; i<nK; i++) K[i] -> s[0] = i;}

// quick sort by decreasing 'sig'
// (then decreasing 'rel')
// (then increasing frequency)
int compare_sig (const void* alpha1, const void* alpha2)
{stem_list_t K1, K2; K1 = (stem_list_t) alpha1; K2 = (stem_list_t) alpha2;
 if (
     ((*K1) -> sig < (*K2) -> sig) ||
     (
      ((*K1) -> sig == (*K2) -> sig) &&
      ((*K1) -> rel < (*K2) -> rel)
      ) ||
     (
      ((*K1) -> sig == (*K2) -> sig) &&
      ((*K1) -> rel == (*K2) -> rel) &&
      ((*K1) -> freq < (*K2) -> freq)
      )
     )
   return 1; else return -1;}
void sort_stems_by_sig (stem_list_t K)
{int i; int nK = stem_list_length(K);
 qsort(K, nK, sizeof(stem_t), compare_sig);
 for (i=0; i<nK; i++) K[i] -> s[0] = i;}

// quick sort by decreasing index
// (then decreasing 'rel')
// (then increasing frequency)
int compare_index (const void* alpha1, const void* alpha2)
{stem_list_t K1, K2; K1 = (stem_list_t) alpha1; K2 = (stem_list_t) alpha2;
 if (
     ((*K1) -> index < (*K2) -> index) ||
     (
      ((*K1) -> index == (*K2) -> index) &&
      ((*K1) -> rel < (*K2) -> rel)
      ) ||
     (
      ((*K1) -> index == (*K2) -> index) &&
      ((*K1) -> rel == (*K2) -> rel) &&
      ((*K1) -> freq < (*K2) -> freq)
      )
     )
   return 1; else return -1;}
void sort_stems_by_index (stem_list_t K)
{int i; int nK = stem_list_length(K);
 qsort(K, nK, sizeof(stem_t), compare_index);
 for (i=0; i<nK; i++) K[i] -> s[0] = i;}

// quick sort by lexicographic order: s[1] < s[2] < s[3]
int compare_begin (const void* alpha1, const void* alpha2)
{stem_list_t K1, K2; K1 = (stem_list_t) alpha1; K2 = (stem_list_t) alpha2;
 if (((*K1)->s[1] > (*K2)->s[1]) ||
     (((*K1)->s[1] == (*K2)->s[1]) && ((*K1)->s[2] > (*K2)->s[2])) ||
     ((((*K1)->s[1] == (*K2)->s[1]) && ((*K1)->s[2] == (*K2)->s[2]))
      && ((*K1)->s[3] > (*K2)->s[3]))) return 1; else return -1;}
void sort_stems_by_begin (stem_list_t K)
{int i; int nK = stem_list_length(K);
 qsort(K, nK, sizeof(stem_t), compare_begin);
 for (i=0; i<nK; i++) K[i] -> s[0] = i;}

// quick sort by antilexicographic order: s[3] > s[4]
int compare_end (const void* alpha1, const void* alpha2)
{stem_list_t L1, L2; L1 = (stem_list_t) alpha1; L2 = (stem_list_t) alpha2;
 if (((*L1)->s[4] > (*L2)->s[4]) ||
     (((*L1)->s[4] == (*L2)->s[4]) && ((*L1)->s[3] > (*L2)->s[3])))
   return 1; else return -1;}
stem_list_t sort_stems_by_end (stem_list_t K_in)
{int i,nK; stem_list_t K_out;
 nK = stem_list_length(K_in); K_out = new_stem_list (nK);
 for(i=0; i<=nK; i++) K_out[i]=K_in[i];
 qsort(K_out, nK, sizeof(stem_t), compare_end); return K_out;}

int same_stem (stem_t K1, stem_t K2) {
  return
    (K1->s[4] == K2->s[4]) &&
    (K1->s[3] == K2->s[3]) &&
    (K1->s[2] == K2->s[2]) &&
    (K1->s[1] == K2->s[1]);}

// P1--P2-..-P2--P1
int test_father (stem_t P1, stem_t P2)
{return ((P1->s[2]<P2->s[1]) && (P2->s[4]<P1->s[3]));}
int test_almost_father (stem_t P1, stem_t P2, int overlap)
{return ((P1->s[2]<P2->s[1]+overlap) &&
	 (P2->s[4]<P1->s[3]+overlap));}
// P1..P1--P2..P2
int test_brother (stem_t P1, stem_t P2)
{return (P1->s[4]<P2->s[1]);}
int test_almost_brother (stem_t P1, stem_t P2, int overlap)
{return (P1->s[4]<P2->s[1]+overlap);}

int is_compatible (stem_t P, stem_list_t K)
{int i, n, out, sure; out = 1; sure = 0; n = stem_list_length (K);
 for (i=0; (i<n) && (out) && (!sure); i++) { 
   out *= ((test_father (P, K[i])) || (test_brother (P, K[i])) ||
	   (test_father (K[i], P)) || (test_brother (K[i], P)));
   sure = (P == K[i]);}
 return out + sure;}

// almost compatible --> return 1
// belongs to stem list --> return 2
int is_almost_compatible (stem_t P, stem_list_t K)
{int i, n, out, sure; int OVERLAP = 3;
 out = 1; sure = 0; n = stem_list_length (K);
 for (i=0; (i<n) && (out) && (!sure); i++) { 
   out *= ((test_almost_father (P, K[i], OVERLAP)) ||
	   (test_almost_brother (P, K[i], OVERLAP)) ||
	   (test_almost_father (K[i], P, OVERLAP)) ||
	   (test_almost_brother (K[i], P, OVERLAP)));
   sure = (P == K[i]);}
 return out + 2 * sure;}

int adjust (stem_t p, stem_t q) {
  extern sequence_list_t seq;
  int seq_n0, seq_n1, k, shift;
  int long0, long1, score, score_min, delta;
  seq_n0 = seq[0].length;
  seq_n1 = seq[1].length;
  long0 = p->s[2] - p->s[1] + 1;
  long1 = q->s[2] - q->s[1] + 1;
  score_min = 1000; delta = 0;
  // delta est le dcalage optimal de (l'ouverture de) la
  // deuxime tige par rapport  (l'ouverture de) la premire
  if (long1 >= long0) {
    for (shift=0; shift>=long0-long1; shift--) {
      score = 0;
      for (k=0; k<long1; k++) {
	score += (seq[0].nucl[p->s[1]+k] != seq[1].nucl[q->s[1]+k-shift]);
	score += (seq[0].nucl[p->s[4]-k] != seq[1].nucl[q->s[4]-k+shift]);
      }
      if (score < score_min) {score_min = score; delta = shift;}}}
  else {
    for (shift=0; shift<=long0-long1; shift++) {
      score = 0;
      for (k=0; k<long0; k++) {
	score += (seq[0].nucl[p->s[1]+k+shift] != seq[1].nucl[q->s[1]+k]);
	score += (seq[0].nucl[p->s[4]-k-shift] != seq[1].nucl[q->s[4]-k]);
      }
      if (score < score_min) {score_min = score; delta = shift;}}}
  return delta;
}

// identity = true if p (resp. q)
// is a 'factor stem' of q (resp. p)

int identity (stem_t p, stem_t q) {
  extern sequence_list_t all_seq;
  sequence_t seq0, seq1;
  int k, delta, long0, long1, long_min;
  char a0, a1, b0, b1;
  seq0 = all_seq[p->seq];
  seq1 = all_seq[q->seq];
  delta = adjust (p,q);
  long0 = p->s[2] - p->s[1] + 1;
  long1 = q->s[2] - q->s[1] + 1;
  long_min = MIN (long0, long1);
  for (k=0; k<long_min; k++) {
    a0 = seq0.nucl[p->s[1]+k+MAX(delta,0)];
    b0 = seq0.nucl[p->s[4]-k-MAX(delta,0)];
    a1 = seq1.nucl[q->s[1]+k+MAX(-delta,0)];
    b1 = seq1.nucl[q->s[4]-k-MAX(-delta,0)];
/*      a0 = seq0.nucl[p->s[1]+k]; */
/*      b0 = seq0.nucl[p->s[4]-k]; */
/*      a1 = seq1.nucl[q->s[1]+k]; */
/*      b1 = seq1.nucl[q->s[4]-k]; */
    if ((a0 != a1) || (b0 != b1)) return 0;
  } return 1;}


int uncovary (stem_t p, stem_t q) {
  extern sequence_list_t all_seq;
  sequence_t seq0, seq1;
  int k, delta, long0, long1, long_min;
  char a0, a1, b0, b1;
  seq0 = all_seq[p->seq];
  seq1 = all_seq[q->seq];
  delta = adjust (p,q);
  long0 = p->s[2] - p->s[1] + 1;
  long1 = q->s[2] - q->s[1] + 1;
  long_min = MIN (long0, long1);
  for (k=0; k<long_min; k++) {
    a0 = seq0.nucl[p->s[1]+k+MAX(delta,0)];
    b0 = seq0.nucl[p->s[4]-k-MAX(delta,0)];
    a1 = seq1.nucl[q->s[1]+k+MAX(-delta,0)];
    b1 = seq1.nucl[q->s[4]-k-MAX(-delta,0)];
    if (covariation (a0, a1, b0, b1)) return 0;
  }
  return 1;
}

int substem (stem_t K1, stem_t K2) {
  return
    (K1->s[1] >= K2->s[1]) &&
    (K1->s[2] <= K2->s[2]) &&
    (K1->s[3] >= K2->s[3]) &&
    (K1->s[4] <= K2->s[4]) &&
    (K1->s[1]+K1->s[4] == K2->s[1]+K2->s[4]);}

int meet_substem (stem_t P, stem_list_t K) {
  int i; int n=stem_list_length(K);
  for (i=0; i<n; i++)
    if ((!same_stem(P,K[i])) && (substem(P,K[i]))) return 1;
  return 0;}

int one_common_bp (stem_t P, stem_t Q) {

  int a,b,c,d,aa,bb,cc,dd;

  a = P -> s[1]+1;
  b = P -> s[2]+1;
  c = P -> s[3]+1;
  d = P -> s[4]+1;

  aa = Q -> s[1]+1;
  bb = Q -> s[2]+1;
  cc = Q -> s[3]+1;
  dd = Q -> s[4]+1;

  return ((((a<=aa) && (aa<=b)) ||
	   ((aa<=a) && (a<=bb)))
	  && (a+d == aa+dd));
}

// equiv_shifted = true
// if the opening (resp. the closure)
// of P and Q have at least 1 base in common

int equiv_shifted (stem_t P, stem_t Q)
{return
   (!(Q->s[2] < P->s[1])) && (!(P->s[2] < Q->s[1])) &&
   (!(Q->s[4] < P->s[3])) && (!(P->s[4] < Q->s[3]));}

// equiv_stem = true if P
// . either has at least 1 bp in common with Q
// . either is stacked on Q
//  (1 common base is allowed
//  when stacking is checked)
// P and Q play the same role

int equiv_stem (stem_t P, stem_t Q) {
  int OVERLAP = 2;
  int MAX_DIST = 5;
  return ((one_common_bp (P, Q)) ||
	  ((Q->s[1]-P->s[2] + P->s[3]-Q->s[4] <= MAX_DIST) &&
	   (test_almost_father (P, Q, OVERLAP))) ||
	  ((P->s[1]-Q->s[2] + Q->s[3]-P->s[4] <= MAX_DIST) &&
	   (test_almost_father (Q, P, OVERLAP))));
}

/*  void shorten_stems (stem_list_t K) { */
/*    int i, n; */
/*    int SHORT1=1; */
/*    int SHORT2=2; */
/*    n = stem_list_length (K); */
/*    for(i=0; i<n; i++) */
/*      if (K[i]->s[2] - K[i]->s[1] > 2*SHORT2) { */
/*        K[i]->shortened = SHORT2; */
/*        K[i]->s[1] += SHORT2; */
/*        K[i]->s[2] -= SHORT2; */
/*        K[i]->s[3] += SHORT2; */
/*        K[i]->s[4] -= SHORT2; */
/*      } */
/*      else if (K[i]->s[2] - K[i]->s[1] > 2*SHORT1) { */
/*        K[i]->shortened = SHORT1; */
/*        K[i]->s[1] += SHORT1; */
/*        K[i]->s[2] -= SHORT1; */
/*        K[i]->s[3] += SHORT1; */
/*        K[i]->s[4] -= SHORT1; */
/*      } */
/*  } */

void shorten_stems (stem_list_t K) {
  int i, n;
  int SHORT=2;
  n = stem_list_length (K);
  for(i=0; i<n; i++)
    if (K[i]->s[2] - K[i]->s[1] > 2*SHORT + 1) {
      K[i]->shortened = SHORT;
      K[i]->s[1] += SHORT;
      K[i]->s[2] -= SHORT;
      K[i]->s[3] += SHORT;
      K[i]->s[4] -= SHORT;
    }
}

void extend_stems (stem_list_t K) {
  int i, n;
  n = stem_list_length (K);
  for(i=0; i<n; i++)
    if (K[i]->shortened) {
      K[i]->s[1] -= K[i]->shortened;
      K[i]->s[2] += K[i]->shortened;
      K[i]->s[3] -= K[i]->shortened;
      K[i]->s[4] += K[i]->shortened;
      K[i]->shortened = 0;
    }}

stem_list_t erase_copies (stem_list_t K_in) {
  int i,j,nK; stem_list_t K_out;
  nK = stem_list_length(K_in);
  K_out = new_stem_list (nK);
  j=0; K_out[0]=K_in[0]; i=1;
  while (i<nK) {
    // ??    while ((i<nK-1) && (same_stem(K_out[j], K_in[i]))) i++;
    while ((i<nK) && (same_stem(K_out[j], K_in[i]))) i++;
    j++; K_out[j] = K_in[i]; i++;}
  // printf ("[%3i er] ", nK - stem_list_length(K_out));
  free (K_in); return K_out;}

void print_stem (stem_t P)
{int j; extern sequence_list_t all_seq; sequence_t seq;
 if (P) {
   printf("."); fflush(stdout);
   seq = all_seq[P->seq];
   printf(" %4i [%s] ", P->seq+1, int2string(P->flag, 1));
   printf ("%4i:%4i", P->s[1]+1, P->s[2]+1);
   printf (" / %4i:%4i |", P->s[3]+1, P->s[4]+1);
   printf (" %5i |", P->energy);
   printf (" %2i |", P->freq);
   //   printf (" %2i |", P->last_out);
   //   printf (" %2i |", P->next_in);
   //   printf (" %2i |", P->last_in);
   if (P->substem) printf ("sub|"); else printf ("   |");
   if (P->true_match>=10) printf("m|");
   else if (P->true_match>0) printf("s|");
   else printf(" |");
   for (j=P->s[1]; j<=P->s[2]; j++)
     printf ("%c", seq.nucl[j]); printf (" / ");
   for (j=P->s[3]; j<=P->s[4]; j++)
     printf ("%c", seq.nucl[j]); printf ("\n");}
 else printf ("          NULL stem\n");}

void print_stem_list (string_t msg, stem_list_t K, int x) {
  extern sequence_list_t all_seq;
  int i, j, n; FILE *out;
  out = fopen("output/stems.out","a");
  n = stem_list_length (K);
  fprintf(out, "\n\n %s \n", msg);
  fprintf(out, "\n\n %2i - %s\n", x+1, all_seq[x].name);
  fprintf(out,"________________________________");
  fprintf(out,"________________________________\n");
  for(i=0; i<n; i++) {
    fprintf(out, "%2i", x+1);
    fprintf(out, " [%s]", int2string(K[i]->flag,1));
    fprintf(out," %4i|", K[i]->s[0]+1);
    fprintf(out,"%4i:%4i", K[i]->s[1]+1, K[i]->s[2]+1);
    fprintf(out," / %4i:%4i |", K[i]->s[3]+1, K[i]->s[4]+1);
    fprintf(out," %5i|", K[i]->energy);
    if (K[i]->true_match>=10) fprintf(out,"m|");
    else if (K[i]->true_match>0) fprintf(out,"s|");
    else fprintf(out," |");
    for(j=K[i]->s[1]; j<=K[i]->s[2]; j++) fprintf(out,"%c", all_seq[x].nucl[j]);
    fprintf(out," / ");
    for(j=K[i]->s[3]; j<=K[i]->s[4]; j++) fprintf(out,"%c", all_seq[x].nucl[j]);
    fprintf(out,"\n");}
  fprintf(out,"________________________________");
  fprintf(out,"________________________________\n\n");
  fclose(out);}


void print_reference_stems (sequence_list_t all_seq, int x, stem_list_t K) {
  int i, j, n; FILE *out;
  out = fopen("output/reference.out","a");
  n = stem_list_length (K);
  fprintf(out, "\n\n %2i - %s\n", x+1, all_seq[x].name);	  
  fprintf(out,"________________________________");
  fprintf(out,"________________________________\n");
  fprintf(out,"     |                      | |\n");
  for(i=0; i<n; i++) {
    fprintf(out," %4i|", K[i]->s[0]+1);
    fprintf(out,"%4i:%4i", K[i]->s[1]+1, K[i]->s[2]+1);
    fprintf(out," / %4i:%4i |", K[i]->s[3]+1, K[i]->s[4]+1);
    if (K[i]->true_match>=10) fprintf(out,"m|");
    else if (K[i]->true_match>0) fprintf(out,"s|");
    else fprintf(out," |");
    for(j=K[i]->s[1]; j<=K[i]->s[2]; j++) fprintf(out,"%c", all_seq[x].nucl[j]);
    fprintf(out," / ");
    for(j=K[i]->s[3]; j<=K[i]->s[4]; j++) fprintf(out,"%c", all_seq[x].nucl[j]);
    fprintf(out,"\n");}
  fprintf(out,"________________________________");
  fprintf(out,"________________________________\n\n");
  fclose(out);}

void print_true_stems (sequence_list_t all_seq, int x, stem_list_t K) {
  extern stem_list_t *finalR;
  int i, k, n; FILE *true;
  n = stem_list_length (K);
  true = fopen("output/true.out","a");
  fprintf (true, "\n\n %2i - %s\n", x+1, all_seq[x].name);	  
  for(i=0; i<n; i++) {
    if ((K[i] -> true_match >= 10) && (K[i] -> true_match < 20)) {
      fprintf (true, "[%s] ", int2string(K[i]->flag,1));
      fprintf (true, "%4i:%4i", K[i]->s[1]+1, K[i]->s[2]+1);
      fprintf (true, " / %4i:%4i |", K[i]->s[3]+1, K[i]->s[4]+1);
      // index
      if (K[i]->index != -1) fprintf (true, " %3i |", K[i]->index);
      else fprintf(true,"     |");
      // belongs to final structure ?
      if (belongs(K[i], finalR[x])) fprintf(true,"*|");
      else fprintf(true," |");
      // true match ? (should always be 'm')
      if (K[i]->true_match>=10) fprintf(true,"m|");
      else if (K[i]->true_match>0) fprintf(true,"s|");
      else fprintf(true," |");
      // substem ?
      if (K[i]->substem) fprintf (true, "sub|");
      else fprintf (true, "   |");
      // sequence
      for (k=K[i]->s[1]; k<=K[i]->s[2]; k++)
	fprintf (true, "%c", all_seq[x].nucl[k]);
      fprintf (true, " / ");
      for (k=K[i]->s[3]; k<=K[i]->s[4]; k++)
	fprintf (true, "%c", all_seq[x].nucl[k]);
      fprintf (true, "\n");}}
  fclose(true);}


void print_forced_stems (sequence_list_t all_seq, int x) {
  extern stem_list_t *forced_stems;
  int i, k, n; FILE *forced;
  stem_list_t K = forced_stems[x];
  n = stem_list_length (K);
  forced = fopen("output/forced.out","a");
  fprintf (forced, "\n\n %2i - %s\n", x+1, all_seq[x].name);	  
  for(i=0; i<n; i++) {
    fprintf (forced, "[%s] ", int2string(K[i]->flag,1));
    fprintf (forced, "%4i:%4i", K[i]->s[1]+1, K[i]->s[2]+1);
    fprintf (forced, " / %4i:%4i |", K[i]->s[3]+1, K[i]->s[4]+1);
    // sequence
    for (k=K[i]->s[1]; k<=K[i]->s[2]; k++)
      fprintf (forced, "%c", all_seq[x].nucl[k]);
    fprintf (forced, " / ");
    for (k=K[i]->s[3]; k<=K[i]->s[4]; k++)
      fprintf (forced, "%c", all_seq[x].nucl[k]);
    fprintf (forced, "\n");}
  fclose(forced);}


void print_remaining_stems (sequence_list_t all_seq, int x, stem_list_t K) {
  extern stem_list_t *finalR;
  int i, k, n; FILE *rem;
  n = stem_list_length (K);
  rem = fopen("output/remain.out","a");
  fprintf (rem, "\n\n %2i - %s\n", x+1, all_seq[x].name);
  for(i=0; i<n; i++) {
    fprintf (rem, "[%s] ", int2string(K[i]->flag,1));
    fprintf (rem, "%4i:%4i", K[i]->s[1]+1, K[i]->s[2]+1);
    fprintf (rem, " / %4i:%4i |", K[i]->s[3]+1, K[i]->s[4]+1);
    // index
    if (K[i]->index != -1) fprintf (rem, " %3i |", K[i]->index);
    else fprintf(rem,"     |");
    // belongs to final structure ?
    if (belongs(K[i], finalR[x])) fprintf(rem,"*|");
    else fprintf(rem," |");
    // match ?
    if (K[i]->true_match>=10) fprintf(rem,"m|");
    else if (K[i]->true_match>0) fprintf(rem,"s|");
    else fprintf(rem," |");
    // substem ?
    if (K[i]->substem) fprintf (rem, "sub|");
    else fprintf (rem, "   |");
    // sequence
    for (k=K[i]->s[1]; k<=K[i]->s[2]; k++)
      fprintf (rem, "%c", all_seq[x].nucl[k]);
    fprintf (rem, " / ");
    for (k=K[i]->s[3]; k<=K[i]->s[4]; k++)
      fprintf (rem, "%c", all_seq[x].nucl[k]);
    fprintf (rem, "\n");}
  fclose(rem);
}


void print_married_stems (stem_list_t S) {
  int i, j, n; extern int nb_seq;
  n = stem_list_length (S);
  for (j=0; j<n; j++) {
    printf ("\n-->"); print_stem (S[j]);
    for (i=0; i<nb_seq; i++)
      print_stem (S[j]->married[i]);}
}


// classes
class_t new_class (int open_absc, int close_absc,
		   stem_list_t K, int begin, int end) {
  int i; class_t new;
  new = (class_t) malloc(sizeof(_class_t));
  if (K!=NULL) {
    new -> stem_list = new_stem_list (end-begin+1);
    for (i=begin; i<=end; i++) {
      (new -> stem_list)[i-begin] = (stem_t) malloc(sizeof(_stem_t));
      (new -> stem_list)[i-begin] = K[i];}
    (new -> stem_list)[end-begin+1] = NULL;
    new -> size = stem_list_length (new -> stem_list);}
  else {new -> stem_list = NULL; new -> size = 0;}
  new -> open_absc = open_absc;
  new -> close_absc = close_absc;
  return new;}
class_list_t new_class_list (int size_list) {
  class_list_t list;
  list = (class_list_t) malloc((size_list+1)*sizeof(class_t));
  list[0] = new_class (-1, -1, NULL, 0, -1);
  return list;}
int class_list_length (class_list_t x)
{int i; for(i=0; (x[i]->stem_list!=NULL); i++); return i;}
void print_class_list (class_list_t x) {
  int i,j,l; FILE *out;
  out = fopen("output/classes.out", "a");
  l = class_list_length (x); fprintf (out, "\n");
  for(i=0; i<l; i++) {
    fprintf (out, "[ (%2i) - %3i .. %3i ] [", i+1,
	     x[i] -> open_absc+1, x[i] -> close_absc+1);
    for(j=0; j<x[i]->size; j++)
      fprintf (out, "%i.", (x[i]->stem_list)[j]->s[0]+1);
/*      fprintf (out, "]\n                      ["); */
/*      for(j=0; j<x[i]->size; j++) */
/*        fprintf (out, "%s.", int2string((x[i]->stem_list)[j]->flag)); */
    fprintf (out, "]\n");} fclose (out);}

// blocs
block_t new_block (int begin0, int begin1, int length, int mism){
  block_t b; b = (block_t) malloc(sizeof(_block_t));
  b->begin[0] = begin0; b->begin[1] = begin1;
  b->length = length; b->mism = mism; return b;}
block_list_t alloc_block_list (int size)
{block_list_t b; b = (block_list_t) malloc((size+1)*sizeof(block_t));
 b[0]=NULL; return b;}
void free_block_list (block_list_t b)
{int i, n; n = block_list_length (b); for (i=-1; i<n; i++) free (b[i]); free(b);}
int block_list_length (block_list_t b)
{int i; for(i=0; (b[i]!=NULL); i++); return i;}
int weight (int length, int mism)
{return rel_weight (0, 0, length, mism);}
int rel_weight (int rel_x0, int rel_x1, int length, int mism) {
  int k; float proba=0;
  int SEUIL_LENGTH_BLOCKS = 30;
  // WARN !! bino computed only below 32 !!
  // so SEUIL_LENGTH_BLOCKS should be less than 32
  if (length <= 5) return 0;
  if (length <= SEUIL_LENGTH_BLOCKS) {
    for (k=0; k<=mism; k++)
      proba += (float) bino[length][k] * power(3, k);
    proba *= power(.25, length);
    proba *= (float) (1 + ABS (rel_x1 - rel_x0));
    //  proba *= (float) (1 + ABS (rel_x1 - rel_x0) * ABS (rel_x1 - rel_x0));
    if (proba!=0) return (int) - 10 * log (proba);
    else return Z;}
  return Z;}
void print_blocks (block_list_t ** block_list, int i, int j) {
  extern sequence_list_t all_seq;
  //  int ii, jj, t;
  int k, n, esp, pr; FILE *out;
  out = fopen("output/blocks.out", "a");
  n = block_list_length (block_list[i][j]);
  fprintf (out, "\n\n %2i *** %s ***\n", i+1, all_seq[i].name);
  fprintf (out, " %2i *** %s ***\n\n", j+1, all_seq[j].name);
  for (k=0; k<n; k++) {
/*      ii = block_list[i][j][k]->begin[0]; */
/*      fprintf (out, "\n%4i -- ", ii+1); */
/*      for (t=0; t<block_list[i][j][k]->length; t++) */
/*        fprintf (out,"%c",all_seq[i].nucl[i+t]); */
/*      fprintf (out, " -- %4i", ii+t); */
/*      jj=block_list[i][j][k]->begin[1]; */
/*      fprintf (out, "\n%4i -- ", jj+1); */
/*      for (t=0; t<block_list[i][j][k]->length; t++) */
/*        fprintf (out,"%c",all_seq[j].nucl[j+t]); */
/*      fprintf (out, " -- %4i\n", jj+t); */
/*      fprintf (out, "\n"); */
    fprintf (out, "[length: %4i ", block_list[i][j][k]->length);
    fprintf (out, "mism: %3i ", block_list[i][j][k]->mism);
    fprintf (out, "abs dist: %3i ", block_list[i][j][k]->begin[0]-
	     block_list[i][j][k]->begin[1]);
    if (k)
      fprintf (out, "rel dist: %3i ",
	       ABS (block_list[i][j][k]->begin[0]-
		    block_list[i][j][k-1]->begin[0]-
		    block_list[i][j][k]->begin[1]+
		    block_list[i][j][k-1]->begin[1]));
    else fprintf (out, "              ");
    pr = weight (block_list[i][j][k]->length,
		 block_list[i][j][k]->mism);
    if (pr != Z) fprintf (out, "pr: %3i ", pr);
    else fprintf (out, "pr: *** ");
    if (k) esp = MAX (rel_weight (block_list[i][j][k]->begin[0],
				  block_list[i][j][k]->begin[1],
				  block_list[i][j][k]->length,
				  block_list[i][j][k]->mism),
		      rel_weight (block_list[i][j][k]->begin[0]-
				  block_list[i][j][k-1]->begin[0],
				  block_list[i][j][k]->begin[1]-
				  block_list[i][j][k-1]->begin[1],
				  block_list[i][j][k]->length,
				  block_list[i][j][k]->mism));
    else esp = rel_weight (block_list[i][j][k]->begin[0],
			   block_list[i][j][k]->begin[1],
			   block_list[i][j][k]->length,
			   block_list[i][j][k]->mism);
    if (esp != Z) fprintf (out, "esp: %3i]\n", esp);
    else  fprintf (out, "esp: ***]\n");}
  //  fprintf (out, "\n\n");
  fclose (out);}

// matrices
matrix2_t alloc_matrix2 (int a, int b, int fill) {
  matrix2_t mat; int i,j;
  mat = (matrix2_t) malloc((a+1)*sizeof(vector_t));
  mat ++; for (i=-1; i<a; i++)
    {mat[i] = (vector_t) malloc((b+1)*sizeof(int)); mat[i] ++;
    for(j=-1; j<b; j++) {mat[i][j] = fill;}} return mat;}
void free_matrix2 (matrix2_t mat, int a)
{int i; for (i=-1; i<a; i++) {mat[i] --; free(mat[i]);} mat--; free(mat);}
void print_matrix2 (matrix2_t mat, int a, int b, int l, int n) {
  int i, j;
  printf ("\n\n     |");
  for (j=MAX(b-l,0);   j<MIN(b+l,n-1); j++) printf ("%4i|", j);
  printf("\n ");
  for (j=MAX(b-l,0)-1; j<MIN(b+l,n-1); j++) printf ("-----");
  printf("\n");
  for (i=MAX(a-l,0); i<MIN(a+l,n-1); i++) {
    printf ("%4i |", i);
    for (j=MAX(b-l,0); j<MIN(b+l,n-1); j++) {
      if (ABS(i-j)<=1) printf ("  - |");
      else if (!mat[i][j]) printf ("    |");
      else printf ("%4i|",-mat[i][j]);}
    printf("\n");}
  printf(" ");
  for (j=MAX(b-l,0)-1; j<MIN(b+l,n-1); j++) printf ("-----");
  printf("\n\n");}

// misc.
int canoniq (char a, char b)
{return CG(a,b) || AU(a,b) || GU(a,b) || CG(b,a) || AU(b,a) || GU(b,a);}
int covariation (char a0, char a1, char b0, char b1)
{return ((a0 != a1) && (b0 != b1) && canoniq (a0, b0) && canoniq (a1, b1));}
string_t int2string (int n, int up)
{int i; char *res; char tab[33] =
		   {'A','B','C','D','E','F','G','H','J','K','L','M',
		    'N','P','Q','R','S','T','U','V','W','X','Y','Z',
		    '1','2','3','4','5','6','7','8','9'};
 res = malloc (4*sizeof(char));
 res[3] = '\0';
 res[2] = tab[n % 33]; n /=33;
 res[1] = tab[n % 33]; n /=33;
 res[0] = tab[n % 33];
 if (!up) for (i=0; i<3; i++) res[i] = (char)tolower((int)res[i]);
 // if (res[0] == 'A') res[0] = ' ';
 return res;}
float power (float x, int n)
{float p=1; while(n--) p *= x; return p;}

int is (char x, string_t alphabet) {
  int i,j; char a;
  i=0; j=0; while ((a=alphabet[i]) != '\0')
    {if (x == alphabet[i]) j=1; i++;}
  return j;}

int break_loop (int i, int j, string_t msg) {
  extern int brk_lp;
  extern sequence_list_t all_seq;
  if (brk_lp) {
    brk_lp=0;
    if (!strcmp(msg,"no block"))
      {all_seq[i].cofold[j] = 0; all_seq[j].cofold[i] = 0;}
    // if(VERBOSE) printf("            broken: %s\n", msg);
    if(VERBOSE) printf("\n");
    return 1;
  }
  else {
    return 0;
  }
}
